=== doc/CMakeLists.txt ===
if (NOT WIN32)
    add_subdirectory(man)
endif()
add_subdirectory(html)
