=== doc/src/requirements.txt ===
Sphinx>=1.6.5
# breathe>=4.6.0
sphinx_rtd_theme
