=== debian/changelog ===
tango (9.4.2+dfsg1-1) unstable; urgency=low

  * Team Upload

  * New upstream version 9.4.2+dfsg1
  * Remove RELEASE: experimental in d/gitlab-ci.yml
  * Update Files-Excluded in d/copyright
  * Add d/patches/set-default-date-current_date-table-script.patch
  * Initial systemd support (Closes: #1039389). Thanks to Picca
    Frédéric-Emmanuel for the review!
  * Comment out Suggests: omninotify in tango-starter. omninotify is not found in debian
  * Add initial d/test/starter-basic autopkgtest

 -- Santiago Ruano Rincón <santiago@freexian.com>  Thu, 10 Aug 2023 13:40:09 -0300
